org.apache.felix.ipojo.manipulation

## Class MethodDescriptor

- java.lang.Object
- - org.apache.felix.ipojo.manipulation.MethodDescriptor

    public class MethodDescriptor
    extends Object

Method Descriptor describe a method.

Author:
  Felix Project Team

### Constructor Summary

Constructors
Constructor and Description
`MethodDescriptor(String name, String desc, boolean isStatic)` Constructor.

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `addAnnotation(ClassChecker.AnnotationDescriptor ann)` Add an annotation to the current method.
`void` `addLocalVariable(String name, String desc, String signature, int index)`
`void` `addParameterAnnotation(int id, ClassChecker.AnnotationDescriptor ann)` Add an annotation to the current method.
`void` `end()`
`List<ClassChecker.AnnotationDescriptor>` `getAnnotations()`
`List<org.objectweb.asm.tree.LocalVariableNode>` `getArgumentLocalVariables()`
`String` `getDescriptor()`
`org.apache.felix.ipojo.metadata.Element` `getElement()` Compute method manipulation metadata.
`LinkedHashMap<Integer,org.objectweb.asm.tree.LocalVariableNode>` `getLocals()`
`String` `getName()`
`Map<Integer,List<ClassChecker.AnnotationDescriptor>>` `getParameterAnnotations()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### MethodDescriptor

    public MethodDescriptor(String name,
                            String desc,
                            boolean isStatic)

Constructor.

Parameters:
  `name` - : name of the method.
  `desc` - : descriptor of the method.
  `isStatic` - : is the method static

### Method Detail

#### addAnnotation

    public void addAnnotation(ClassChecker.AnnotationDescriptor ann)

Add an annotation to the current method.

Parameters:
  `ann` - annotation to add

#### addParameterAnnotation

    public void addParameterAnnotation(int id,
                                       ClassChecker.AnnotationDescriptor ann)

Add an annotation to the current method.

Parameters:
  `ann` - annotation to add

#### getAnnotations

    public List<ClassChecker.AnnotationDescriptor> getAnnotations()

#### getParameterAnnotations

    public Map<Integer,List<ClassChecker.AnnotationDescriptor>> getParameterAnnotations()

#### getDescriptor

    public String getDescriptor()

#### getElement

    public org.apache.felix.ipojo.metadata.Element getElement()

Compute method manipulation metadata.

Returns:
  the element containing metadata about this method.

#### getName

    public String getName()

#### addLocalVariable

    public void addLocalVariable(String name,
                                 String desc,
                                 String signature,
                                 int index)

#### end

    public void end()

#### getArgumentLocalVariables

    public List<org.objectweb.asm.tree.LocalVariableNode> getArgumentLocalVariables()

#### getLocals

    public LinkedHashMap<Integer,org.objectweb.asm.tree.LocalVariableNode> getLocals()